=== debian/changelog ===
zimpl (3.3.6-4) unstable; urgency=medium


  * Change Build-Depends: debhelper (>= 11) to debhelper-compat (= 13).
  * Add Vcs-* fields to debian/control.
  * Add patch use-utf8-in-examples.
  * Update patch fix-warnings to fix a new bison warning.

 -- Joachim Reichel <reichel@debian.org>  Sat, 14 Nov 2020 10:38:08 +0100

zimpl (3.3.6-3) unstable; urgency=medium

  * Add autopkgtest support.
  * Update Standards-Version to 4.5.0 (no changes needed)
  * Remove extra code in override_dh_auto_clean target for test w215
    (integrated upstream).

 -- Joachim Reichel <reichel@debian.org>  Tue, 17 Mar 2020 19:07:09 +0100

zimpl (3.3.6-2) unstable; urgency=medium

  * Attempt to fix FTBFS in parallel builds by adding order dependency for
    src/zimpl/mmlparse2.h.
  * Fix sprintf() warnings (no real issue if assertions hold).
  * Update Standards-Version to 4.4.0 (no changes needed).
  * Add Rules-Requires-Root: no to debian/control.

 -- Joachim Reichel <reichel@debian.org>  Tue, 20 Aug 2019 19:39:36 +0200

zimpl (3.3.6-1) unstable; urgency=medium

  * New upstream release.
  * Update Standards-Version to 4.2.1 (no changes needed).
  * Uses Files-Excluded: in debian/copyright, remove get-orig-source
    target in debian/rules.
  * Update content of debian/copyright.

 -- Joachim Reichel <reichel@debian.org>  Sat, 24 Nov 2018 13:16:45 +0100
