=== debian/control ===
Source: zimpl
Section: science
Priority: optional
Maintainer: Joachim Reichel <reichel@debian.org>
Build-Depends: bison,
  debhelper-compat (= 13),
  flex,
  libgmp-dev,
  zlib1g-dev
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: http://zimpl.zib.de/
Vcs-Git: https://salsa.debian.org/reichel/zimpl.git
Vcs-Browser: https://salsa.debian.org/reichel/zimpl

Package: zimpl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: glpk-utils
Description: mathematical modeling language for optimization problems
 Zimpl allows the specification of certain optimization problems - linear
 programs (LPs) and mixed integer programs (MIPs) - in a high-level
 description language. These descriptions can be converted into the
 LP or MPS file formats which are understood by LP and MIP solvers.
