=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_build:
	CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" dh_auto_build -- VERBOSE=true

override_dh_auto_test:
	CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" dh_auto_test -- VERBOSE=true

override_dh_install:
	# replace symbolic link bin/zimpl by the link target
	cp -L bin/zimpl bin/zimpl.real
	rm bin/zimpl
	mv bin/zimpl.real bin/zimpl
	dh_install bin/zimpl usr/bin

override_dh_installexamples:
	dh_installexamples example/*

override_dh_installman:
	dh_installman doc/zimpl.man

override_dh_auto_clean:
	dh_auto_clean
	cd src/zimpl && rm -f mmlparse2.c mmlparse2.h mmlparse2.output mmlscan.c
