## zimpl 3.7.0%2Bds

=== debian/control ===
Source: zimpl
Section: science
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Doug Torrance <dtorrance@debian.org>
Build-Depends: bison,
               cmake,
               debhelper-compat (= 13),
               flex,
               ghostscript,
               libgmp-dev,
               texlive-fonts-extra,
               texlive-latex-base,
               texlive-latex-recommended,
               zlib1g-dev
Standards-Version: 4.7.3
Homepage: http://zimpl.zib.de/
Vcs-Git: https://salsa.debian.org/math-team/zimpl.git
Vcs-Browser: https://salsa.debian.org/math-team/zimpl

Package: zimpl
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: glpk-utils
Description: mathematical modeling language for optimization problems (binary)
 Zimpl allows the specification of certain optimization problems - linear
 programs (LPs) and mixed integer programs (MIPs) - in a high-level
 description language. These descriptions can be converted into the
 LP or MPS file formats which are understood by LP and MIP solvers.
 .
 This package contains the zimpl binary.

Package: libzimpl0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: mathematical modeling language for optimization problems (library)
 Zimpl allows the specification of certain optimization problems - linear
 programs (LPs) and mixed integer programs (MIPs) - in a high-level
 description language. These descriptions can be converted into the
 LP or MPS file formats which are understood by LP and MIP solvers.
 .
 This package contains the zimpl shared library.

Package: libzimpl-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, libzimpl0 (= ${binary:Version})
Description: mathematical modeling language for optimization problems (development)
 Zimpl allows the specification of certain optimization problems - linear
 programs (LPs) and mixed integer programs (MIPs) - in a high-level
 description language. These descriptions can be converted into the
 LP or MPS file formats which are understood by LP and MIP solvers.
 .
 This package contains the zimpl development tools.
