=== Makefile ===
--- 
+++ 
@@ -7,18 +7,18 @@
 #*                                                                           *
 #* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 #*
-#* Copyright (C) 2005-2018 by Thorsten Koch <koch@zib.de>
-#* 
+#* Copyright (C) 2005-2025 by Thorsten Koch <koch@zib.de>
+#*
 #* This program is free software; you can redistribute it and/or
 #* modify it under the terms of the GNU General Public License
 #* as published by the Free Software Foundation; either version 2
 #* of the License, or (at your option) any later version.
-#* 
+#*
 #* This program is distributed in the hope that it will be useful,
 #* but WITHOUT ANY WARRANTY; without even the implied warranty of
 #* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #* GNU General Public License for more details.
-#* 
+#*
 #* You should have received a copy of the GNU General Public License
 #* along with this program; if not, write to the Free Software
 #* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
@@ -26,16 +26,17 @@
 #
 .PHONY:		all depend clean lint doc doxygen check valgrind libdbl coverage
 
-ARCH            :=      $(shell uname -m | \
-                        sed \
-			-e s/sun../sparc/ \
-			-e s/i.86/x86/ \
-			-e s/i86pc/x86/ \
-			-e s/amd64/x86_64/ \
-			-e s/IP../mips/ \
-			-e s/9000..../hppa/ \
-			-e s/Power\ Macintosh/ppc/ \
-			-e s/00........../pwr4/)
+ARCH		:=	$(shell uname -m | \
+			sed \
+			-e 's/sun../sparc/' \
+			-e 's/i.86/x86/' \
+			-e 's/i86pc/x86/' \
+			-e 's/[0-9]86/x86/' \
+			-e 's/amd64/x86_64/' \
+			-e 's/9000..../hppa/' \
+			-e 's/00........../pwr4/' \
+			-e 's/arm.*/arm/' \
+			-e 's/aarch64/arm/')
 OSTYPE          :=      $(shell uname -s | \
                         tr '[:upper:]' '[:lower:]' | \
 			tr '/' '_' | \
@@ -47,13 +48,13 @@
 
 HOSTNAME	:=      $(shell uname -n | tr '[:upper:]' '[:lower:]')
 
-VERSION		=	3.3.6
+VERSION		=  3.7.0
 VERBOSE		=	false
 SHARED		=	false
 STATIC		=	false
 ZLIB		=	true
 LINK		=	static
-OPT		=	opt
+OPT		=	dbg
 COMP		=	gnu
 CC		=	gcc
 CC_o		= 	-o #
@@ -70,7 +71,8 @@
 RANLIB		=	ranlib
 DOXY		=	doxygen
 VALGRIND	=	valgrind --tool=memcheck --leak-check=full \
-			--leak-resolution=high --show-reachable=yes 
+			--leak-resolution=high --show-reachable=yes
+ANALYZER	=	scan-build
 
 SRCDIR		=	src/zimpl
 BINDIR		=	bin
@@ -80,15 +82,62 @@
 CPPFLAGS	=	-I$(SRCDIR)/.. -DVERSION='"$(VERSION)"'
 CFLAGS		=	-O
 LDFLAGS		=	-lgmp -lm
-YFLAGS		=	-d -t -v  
+YFLAGS		=	-d -t -v
 LFLAGS		=	-d
-ARFLAGS		=	
+ARFLAGS		=
 DFLAGS		=	-MM
-
-GCCWARN		=	-Wall -W -Wpointer-arith -Wcast-align -Wwrite-strings \
-			-Wstrict-prototypes -Wmissing-prototypes -Winline \
-			-Wmissing-declarations -Wshadow -Waggregate-return \
-			-Wno-unused -Wno-unknown-pragmas 
+# if changing these flags, also update ADD_C_FLAGS in CMakeLists.txt
+GCCWARN		=	-Wall \
+			-Wextra \
+			-Wno-unknown-pragmas \
+			-Wno-nonnull-compare \
+			-Wno-cast-qual \
+			-Wpointer-arith \
+			-Wcast-align \
+			-Wwrite-strings \
+			-Winline \
+			-Wshadow \
+			-Wstrict-prototypes \
+			-Wmissing-prototypes \
+			-Wmissing-declarations \
+			-Wmissing-noreturn \
+			-Wstrict-overflow=4 \
+			-Wduplicated-branches \
+			-Wsuggest-attribute=pure \
+			-Wsuggest-attribute=const \
+			-Wsuggest-attribute=noreturn \
+			-Wsuggest-attribute=format \
+			-Wno-attributes \
+			-Wno-unused-function \
+			-Wno-unused-parameter \
+			-Wno-nonnull-compare \
+			-Wno-strict-overflow \
+			-fno-omit-frame-pointer \
+			-fstack-protector-strong \
+			-fsanitize=address \
+			-fsanitize=undefined \
+			-fsanitize=shift \
+			-fsanitize=shift-exponent \
+			-fsanitize=shift-base \
+			-fsanitize=integer-divide-by-zero \
+			-fsanitize=unreachable \
+			-fsanitize=vla-bound \
+			-fsanitize=null \
+			-fsanitize=bounds \
+			-fsanitize=alignment \
+			-fsanitize=object-size \
+			-fsanitize=float-cast-overflow \
+			-fsanitize=nonnull-attribute \
+			-fsanitize=returns-nonnull-attribute \
+			-fsanitize=bool \
+			-fsanitize=enum \
+			-fsanitize=signed-integer-overflow \
+#			-Wsuggest-attribute=malloc \
+#			-Wsuggest-attribute=cold \
+#			-fsanitize=pointer-overflow \
+#			-fsanitize=builtin 
+#			-fsanitize=float-divide-by-zero \
+#			-fsanitize=bounds-strict \
 
 ifeq ($(ZLIB),true)
 LDFLAGS		+=	-lz
@@ -124,7 +173,7 @@
 
 OBJECT  	=       zimpl.o xlpglue.o zlpglue.o \
 			ratlpstore.o ratlpfwrite.o ratmpswrite.o ratmstwrite.o \
-			ratordwrite.o ratpresolve.o  
+			ratopbwrite.o ratordwrite.o ratpresolve.o ratqbowrite.o
 LIBBASE		=	blkmem.o bound.o code.o conname.o define.o elem.o entry.o \
 			hash.o heap.o idxset.o inst.o iread.o list.o \
 			load.o local.o metaio.o mmlparse2.o mmlscan.o mono.o \
@@ -176,7 +225,7 @@
 		@rm -f $@
 		cd $(dir $@) && ln -s $(notdir $(BINARY)) $(notdir $@)
 
-$(BINARY):	$(OBJDIR) $(BINDIR) $(OBJXXX) $(LIBRARY) 
+$(BINARY):	$(OBJDIR) $(BINDIR) $(OBJXXX) $(LIBRARY)
 		@echo "-> linking $@"
 ifeq ($(COMP), msvc)
 		$(LINKCC) $(CFLAGS) $(OBJXXX) $(LIBRARY) $(LDFLAGS) $(LINKCC_o)$@
@@ -184,11 +233,11 @@
 		$(LINKCC) $(CFLAGS) $(OBJXXX) -L$(LIBDIR) -l$(LIBNAME) $(LDFLAGS) $(LINKCC_o)$@
 endif
 
-$(BINARYDBL):	$(OBJDIR) $(BINDIR) $(OBJXXX) $(LIBRARYDBL) 
+$(BINARYDBL):	$(OBJDIR) $(BINDIR) $(OBJXXX) $(LIBRARYDBL)
 		@echo "-> linking $@"
 		$(LINKCC) $(CFLAGS) $(OBJXXX) -L$(LIBDIR) -l$(LIBNAME).dbl $(LDFLAGS) $(CC_o)$@
 
-$(LIBRARY):	$(OBJDIR) $(LIBDIR) $(LIBXXX) 
+$(LIBRARY):	$(OBJDIR) $(LIBDIR) $(LIBXXX)
 		@echo "-> generating library $@"
 		-rm -f $(LIBRARY)
 		$(AR) $(AR_o)$@ $(LIBXXX) $(ARFLAGS)
@@ -198,10 +247,10 @@
 
 libdbl:		$(LIBRARYDBL) $(LIBDBLLINK)
 
-$(LIBRARYDBL):	$(OBJDIR) $(LIBDIR) $(LIBDBLXXX) 
+$(LIBRARYDBL):	$(OBJDIR) $(LIBDIR) $(LIBDBLXXX)
 		@echo "-> generating library $@"
 		-rm -f $(LIBRARYDBL)
-		$(AR) $@ $(LIBDBLXXX) $(ARFLAGS) 
+		$(AR) $@ $(LIBDBLXXX) $(ARFLAGS)
 		$(RANLIB) $@
 
 $(SRCDIR)/mmlparse2.c:	$(SRCDIR)/mmlparse2.y $(SRCDIR)/mme.h
@@ -210,11 +259,11 @@
 
 $(SRCDIR)/mmlscan.c:	$(SRCDIR)/mmlscan.l $(SRCDIR)/mme.h
 		@echo "-> generating lex scanner $@"
-		$(LEX) $(LFLAGS) -o$@ $< 
+		$(LEX) $(LFLAGS) -o$@ $<
 
 lint:		$(OBJSRC) $(LIBSRC)
 		$(LINT) $(LINTCONF)/co-gcc.lnt $(SRCDIR)/project2.lnt \
-		-I$(LINTCONF) -I$(SRCDIR) -dNO_MSHELL -dVERSION='"$(VERSION)"' $^
+		-I$(LINTCONF) -I$(SRCDIR)/.. -dNO_MSHELL -dVERSION='"$(VERSION)"' $^
 
 cppcheck:	$(OBJSRC) $(LIBSRC)
 		$(CPPCHECK) $(CPPFLAGS) -I/usr/include -I/usr/include/x86_64-linux-gnu -I/usr/include/x86_64-linux-gnu/bits -I/usr/include/x86_64-linux-gnu/sys -I/usr/include/linux -I/usr/lib/gcc/x86_64-linux-gnu/5/include --inline-suppr --suppressions-list=src/cppcheck.txt --enable=warning,style,performance,portability,information $^
@@ -226,12 +275,17 @@
 		cd doc; $(DOXY) $(NAME).dxy
 
 check:
+		export GLIBC_TUNABLES=glibc.malloc.check=3
 		cd check; \
-		/bin/sh ./check.sh ../$(BINARY) 
+		/bin/sh ./check.sh ../$(BINARY)
 
 valgrind:
 		cd check; \
-		/bin/sh ./check.sh "$(VALGRIND) ../$(BINARY)" 
+		/bin/sh ./check.sh "$(VALGRIND) ../$(BINARY)"
+
+analyze:
+		make clean
+		$(ANALYZER) make
 
 coverage:
 		-ln -s ../../src $(OBJDIR)
@@ -243,7 +297,7 @@
 		genhtml -o gcov gcov/zimpl.capture
 		-rm gcov/z.capture
 
-$(OBJDIR):	
+$(OBJDIR):
 		@echo "** creating directory \"$@\""
 		@-mkdir -p $(OBJDIR)
