=== src/CMakeLists.txt ===
--- 
+++ 
@@ -4,10 +4,10 @@
 file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/zimpl)
 
 # add include directory for bison header
-include_directories(${CMAKE_CURRENT_BINARY_DIR})
+include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR})
 
 # for zimpl headers
-include_directories(zimpl)
+include_directories(BEFORE zimpl)
 
 set(libsources
     zimpl/blkmem.c
@@ -64,10 +64,13 @@
     zimpl/ratlpfwrite.c
     zimpl/ratmpswrite.c
     zimpl/ratmstwrite.c
+    zimpl/ratopbwrite.c
     zimpl/ratordwrite.c
+    zimpl/ratqbowrite.c
     zimpl/ratpresolve.c)
 
 set(headers
+    zimpl/attribute.h
     zimpl/blkmem.h
     zimpl/bound.h
     zimpl/code.h
@@ -107,7 +110,7 @@
     zimpl/zimpllib.h
     zimpl/zlpglue.h)
 
-include_directories(${PROJECT_SOURCE_DIR}/src)
+include_directories(BEFORE ${PROJECT_SOURCE_DIR}/src)
 
 if(MSVC)
    set(headers ${headers} WIN/unistd.h)
@@ -128,21 +131,37 @@
 add_executable(zimpl ${binsources})
 target_link_libraries(zimpl libzimpl ${libs})
 
+if(CMAKE_BUILD_TYPE STREQUAL "Debug")
+    if (SANITIZE_ADDRESS OR SANITIZE_MEMORY OR SANITIZE_THREAD OR SANITIZE_UNDEFINED)
+        find_package(Sanitizers)
+        add_sanitizers(zimpl)
+    endif()
+endif()
+
 set_target_properties(libzimpl PROPERTIES
     OUTPUT_NAME "zimpl")
 
 set_target_properties(libzimpl-pic PROPERTIES
     OUTPUT_NAME "zimpl-pic")
 
+include(GNUInstallDirs)
+
 # install the header files of zimpl
-install(FILES ${headers} DESTINATION include/zimpl)
+install(FILES ${headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/zimpl)
 
 # install the binary and the library to appropriate locations and add them to an export group
 install(TARGETS libzimpl zimpl libzimpl-pic EXPORT zimpl-targets
-        LIBRARY DESTINATION lib
-        ARCHIVE DESTINATION lib
-        RUNTIME DESTINATION bin
-        INCLUDES DESTINATION include)
+        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+        INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
+
+if(MSVC)
+    install(FILES $<TARGET_PDB_FILE:zimpl> DESTINATION ${CMAKE_INSTALL_BINDIR} OPTIONAL)
+endif()
+
+# install the license file of ZIMPL
+install(FILES ${PROJECT_SOURCE_DIR}/LICENSE DESTINATION ${CMAKE_INSTALL_DATADIR}/licenses/zimpl)
 
 # Add library targets to the build-tree export set
 export(TARGETS libzimpl libzimpl-pic
@@ -166,7 +185,16 @@
 configure_file(${PROJECT_SOURCE_DIR}/zimpl-config.cmake.in
   "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/zimpl-config.cmake" @ONLY)
 
+include(CMakePackageConfigHelpers)
+write_basic_package_version_file(
+	 ${CMAKE_BINARY_DIR}/zimpl-config-version.cmake
+	 VERSION ${ZIMPL_VERSION_MAJOR}.${ZIMPL_VERSION_MINOR}.${ZIMPL_VERSION_PATCH}
+	 COMPATIBILITY SameMajorVersion
+	 )
+
 # install the targets of the zimpl export group and the config file so that oter projects
 # can link easily against zimpl
-install(EXPORT zimpl-targets FILE zimpl-targets.cmake DESTINATION lib/cmake/zimpl)
-install(FILES "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/zimpl-config.cmake" DESTINATION lib/cmake/zimpl)
+install(EXPORT zimpl-targets FILE zimpl-targets.cmake DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/zimpl)
+install(FILES "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/zimpl-config.cmake"
+   "${CMAKE_BINARY_DIR}/zimpl-config-version.cmake"
+   DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/zimpl)
