=== debian/changelog ===
zimpl (3.7.0+ds-2) unstable; urgency=medium

  * Source-only upload for transition to testing.
  * ddebian/control
    - Use https in Homepage.

 -- Doug Torrance <dtorrance@debian.org>  Wed, 25 Feb 2026 06:06:40 -0500

zimpl (3.7.0+ds-1) unstable; urgency=medium

  * Re-introduce to Debian (Closes: #1126464).
  * Split into three binary packages (zimpl, libzimpl0, and libzimpl-devel).
  * debian/control
    - Update Maintainer (now Debian Math Team) and add Uploaders field.
    - Update Vcs-* fields.
    - Drop Priority field; "optional" is now the default.
    - Drop redundant Rules-Requires-Root field.
    - Bump Standards-Version to 4.7.3.
    - Add cmake to Build-Depends
    - Add ghostscript, texlive-fonts-extra, texlive-latex-recommded, and
      texlive-latex-base to Build-Depends for building documentation.
  * debian/copyright
    - Stop excluding documentation pdf; its source is included.
    - Remove some directories that aren't included in the tarball generated
      by scripts/makedist.sh (which doesn't appear to be hosted anywhere).
      Some of the files have questionable licenses (images, etc.).
    - Remove old physical Free Software Foundation address from license texts.
    - Update upstream copyright years.
    - Add license info for some cmake files.
    - Add myself to copyright holders for debian directory.
  * debian/gbp.conf
    - New file; set pristine-tar to True and debian-branch to
      debian/latest.
  * debian/libzimpl0.symbols
    - Add symbols file.
  * debian/patches/adapt-build-system
    - Remove patch; we now use the cmake build.
  * debian/patches/check-abort.patch
    - Only check for "Aborted" in error tests. Sometimes "(core dumped)"
      doesn't appear (e.g., on Salsa CI runners).
  * debian/patches/display-test-failures
    - Remove patch to minimize diff from upstream and ease maintenance.
  * debian/patches/fix-warnings
    - Remove patch; issues fixed upstream.
  * debian/patches/shared-library.patch
    - New patch from Fedora; build a shared library.
  * debian/patches
    - Add .patch suffix to remaining patches so Emacs fires up the correct
      major mode.
  * debian/README.Debian
    - Remove file; no longer accurate as we now distribute the
      documentation.
  * debian/README.source
    - Remove file; the fact that we use quilt is clear from "3.0 (quilt)"
      in d/source/format, so no reason to document it further.
  * debian/rules
    - Switch buildsystem to cmake.
    - Drop override_dh_auto_build target; no longer necessary to manually
      set build flags.
    - Remove override_dh_install target; dh_install now does the right
      thing by default.
    - Remove DH_VERBOSE comment.
    - Remove unnecessary override_dh_auto_clean target.
    - Update override_dh_auto_test target to run check.sh script.
    - Add execute_after_dh_auto_build target for building documentation.
    - Add execute_after_dh_auto_clean target for cleaning up artifacts
      from building documentation.
  * debian/salsa-ci.yml
    - Add Salsa CI config file.
  * debian/tests/control
    - Set Depends for autopkgtest to be just zimpl.
  * debian/watch
    - Use uscan v4.
    - Update to use GitHub tags.
    - Deal with repack suffix.
  * debian/zimpl.doc-base
    - New file; register documentation with doc-base.
  * debian/zimpl.docs
    - Rename from docs.
    - Install pdf documentation.

 -- Doug Torrance <dtorrance@debian.org>  Mon, 26 Jan 2026 19:58:25 -0500
