=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
                texlive-latex-recommended,
                zlib1g-dev
 Standards-Version: 4.7.3
-Homepage: http://zimpl.zib.de/
+Homepage: https://zimpl.zib.de/
 Vcs-Git: https://salsa.debian.org/math-team/zimpl.git
 Vcs-Browser: https://salsa.debian.org/math-team/zimpl
