=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk # for DEB_HOST_GNU_TYPE

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

execute_after_dh_auto_build:
	$(MAKE) -C doc

LIBDIR = $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/lib
BINDIR = ../obj-$(DEB_HOST_GNU_TYPE)/bin
override_dh_auto_test:
	cd check && LD_LIBRARY_PATH=$(LIBDIR) sh check.sh $(BINDIR)/zimpl

override_dh_installexamples:
	dh_installexamples example/*

override_dh_installman:
	dh_installman doc/zimpl.man

execute_after_dh_auto_clean:
	$(MAKE) -C doc clean
