=== debian/watch ===
version=4
# we assume that 3-digit tags need dots, e.g., v362 -> 3.6.2
opts=uversionmangle=s/^([0-9])([0-9])([0-9])$/$1.$2.$3/,\
repacksuffix=+ds,dversionmangle=auto,repack \
https://github.com/scipopt/zimpl/tags .*/@ANY_VERSION@@ARCHIVE_EXT@
